/*
 * Linux error numbers
 */
#if !defined(LX_ERRNO_H)
#define	LX_ERRNO_H

#define	LX_EPERM	 1	/* Operation not permitted */
#define	LX_ENOENT	 2	/* No such file or directory */
#define	LX_ESRCH	 3	/* No such process */
#define	LX_EINTR	 4	/* Interrupted system call */
#define	LX_EIO		 5	/* I/O error */
#define	LX_ENXIO	 6	/* No such device or address */
#define	LX_E2BIG	 7	/* Arg list too long */
#define	LX_ENOEXEC	 8	/* Exec format error */
#define	LX_EBADF	 9	/* Bad file number */
#define	LX_ECHILD	10	/* No child processes */
#define	LX_EAGAIN	11	/* Try again */
#define	LX_ENOMEM	12	/* Out of memory */
#define	LX_EACCES	13	/* Permission denied */
#define	LX_EFAULT	14	/* Bad address */
#define	LX_ENOTBLK	15	/* Block device required */
#define	LX_EBUSY	16	/* Device or resource busy */
#define	LX_EEXIST	17	/* File exists */
#define	LX_EXDEV	18	/* Cross-device link */
#define	LX_ENODEV	19	/* No such device */
#define	LX_ENOTDIR	20	/* Not a directory */
#define	LX_EISDIR	21	/* Is a directory */
#define	LX_EINVAL	22	/* Invalid argument */
#define	LX_ENFILE	23	/* File table overflow */
#define	LX_EMFILE	24	/* Too many open files */
#define	LX_ENOTTY	25	/* Not a typewriter */
#define	LX_ETXTBSY	26	/* Text file busy */
#define	LX_EFBIG	27	/* File too large */
#define	LX_ENOSPC	28	/* No space left on device */
#define	LX_ESPIPE	29	/* Illegal seek */
#define	LX_EROFS	30	/* Read-only file system */
#define	LX_EMLINK	31	/* Too many links */
#define	LX_EPIPE	32	/* Broken pipe */
#define	LX_EDOM		33	/* Math argument out of domain of func */
#define	LX_ERANGE	34	/* Math result not representable */
#define	LX_EDEADLK	35	/* Resource deadlock would occur */
#define	LX_ENAMETOOLONG	36	/* File name too long */
#define	LX_ENOLCK	37	/* No record locks available */
#define	LX_ENOSYS	38	/* Function not implemented */
#define	LX_ENOTEMPTY	39	/* Directory not empty */
#define	LX_ELOOP	40	/* Too many symbolic links encountered */
#define	LX_EWOULDBLOCK	EAGAIN	/* Operation would block */
#define	LX_ENOMSG	42	/* No message of desired type */
#define	LX_EIDRM	43	/* Identifier removed */
#define	LX_ECHRNG	44	/* Channel number out of range */
#define	LX_EL2NSYNC	45	/* Level 2 not synchronized */
#define	LX_EL3HLT	46	/* Level 3 halted */
#define	LX_EL3RST	47	/* Level 3 reset */
#define	LX_ELNRNG	48	/* Link number out of range */
#define	LX_EUNATCH	49	/* Protocol driver not attached */
#define	LX_ENOCSI	50	/* No CSI structure available */
#define	LX_EL2HLT	51	/* Level 2 halted */
#define	LX_EBADE	52	/* Invalid exchange */
#define	LX_EBADR	53	/* Invalid request descriptor */
#define	LX_EXFULL	54	/* Exchange full */
#define	LX_ENOANO	55	/* No anode */
#define	LX_EBADRQC	56	/* Invalid request code */
#define	LX_EBADSLT	57	/* Invalid slot */
#define	LX_EDEADLOCK	58	/* File locking deadlock error */
#define	LX_EBFONT	59	/* Bad font file format */
#define	LX_ENOSTR	60	/* Device not a stream */
#define	LX_ENODATA	61	/* No data available */
#define	LX_ETIME	62	/* Timer expired */
#define	LX_ENOSR	63	/* Out of streams resources */
#define	LX_ENONET	64	/* Machine is not on the network */
#define	LX_ENOPKG	65	/* Package not installed */
#define	LX_EREMOTE	66	/* Object is remote */
#define	LX_ENOLINK	67	/* Link has been severed */
#define	LX_EADV		68	/* Advertise error */
#define	LX_ESRMNT	69	/* Srmount error */
#define	LX_ECOMM	70	/* Communication error on send */
#define	LX_EPROTO	71	/* Protocol error */
#define	LX_EMULTIHOP	72	/* Multihop attempted */
#define	LX_EDOTDOT	73	/* RFS specific error */
#define	LX_EBADMSG	74	/* Not a data message */
#define	LX_EOVERFLOW	75	/* Value too large for defined data type */
#define	LX_ENOTUNIQ	76	/* Name not unique on network */
#define	LX_EBADFD	77	/* File descriptor in bad state */
#define	LX_EREMCHG	78	/* Remote address changed */
#define	LX_ELIBACC	79	/* Can not access a needed shared library */
#define	LX_ELIBBAD	80	/* Accessing a corrupted shared library */
#define	LX_ELIBSCN	81	/* .lib section in a.out corrupted */
#define	LX_ELIBMAX	82	/* Attempting to link in too many shared libraries */
#define	LX_ELIBEXEC	83	/* Cannot exec a shared library directly */
#define	LX_EILSEQ	84	/* Illegal byte sequence */
#define	LX_ERESTART	85	/* Interrupted system call should be restarted */
#define	LX_ESTRPIPE	86	/* Streams pipe error */
#define	LX_EUSERS	87	/* Too many users */
#define	LX_ENOTSOCK	88	/* Socket operation on non-socket */
#define	LX_EDESTADDRREQ	89	/* Destination address required */
#define	LX_EMSGSIZE	90	/* Message too long */
#define	LX_EPROTOTYPE	91	/* Protocol wrong type for socket */
#define	LX_ENOPROTOOPT	92	/* Protocol not available */
#define	LX_EPROTONOSUPPORT	93	/* Protocol not supported */
#define	LX_ESOCKTNOSUPPORT	94	/* Socket type not supported */
#define	LX_EOPNOTSUPP	95	/* Operation not supported on transport endpoint */
#define	LX_EPFNOSUPPORT	96	/* Protocol family not supported */
#define	LX_EAFNOSUPPORT	97	/* Address family not supported by protocol */
#define	LX_EADDRINUSE	98	/* Address already in use */
#define	LX_EADDRNOTAVAIL	99	/* Cannot assign requested address */
#define	LX_ENETDOWN	100	/* Network is down */
#define	LX_ENETUNREACH	101	/* Network is unreachable */
#define	LX_ENETRESET	102	/* Network dropped connection because of reset */
#define	LX_ECONNABORTED	103	/* Software caused connection abort */
#define	LX_ECONNRESET	104	/* Connection reset by peer */
#define	LX_ENOBUFS	105	/* No buffer space available */
#define	LX_EISCONN	106	/* Transport endpoint is already connected */
#define	LX_ENOTCONN	107	/* Transport endpoint is not connected */
#define	LX_ESHUTDOWN	108	/* Cannot send after transport endpoint shutdown */
#define	LX_ETOOMANYREFS	109	/* Too many references: cannot splice */
#define	LX_ETIMEDOUT	110	/* Connection timed out */
#define	LX_ECONNREFUSED	111	/* Connection refused */
#define	LX_EHOSTDOWN	112	/* Host is down */
#define	LX_EHOSTUNREACH	113	/* No route to host */
#define	LX_EALREADY	114	/* Operation already in progress */
#define	LX_EINPROGRESS	115	/* Operation now in progress */
#define	LX_ESTALE	116	/* Stale NFS file handle */
#define	LX_EUCLEAN	117	/* Structure needs cleaning */
#define	LX_ENOTNAM	118	/* Not a XENIX named type file */
#define	LX_ENAVAIL	119	/* No XENIX semaphores available */
#define	LX_EISNAM	120	/* Is a named type file */
#define	LX_EREMOTEIO	121	/* Remote I/O error */
#define	LX_EDQUOT	122	/* Quota exceeded */

#endif
