#if !defined(LX_FCNTL_H)
#define	LX_FCNTL_H

/*
 * Linux flags to open() / fcntl()
 */
#define LX_O_ACCMOD	  0003
#define LX_O_RDONLY	    00
#define LX_O_WRONLY	    01
#define LX_O_RDWR	    02
#define LX_O_CREAT	  0100
#define LX_O_EXCL	  0200
#define LX_O_NOCTTY	  0400
#define LX_O_TRUNC	 01000
#define LX_O_APPEND	 02000
#define LX_O_NONBLOCK	 04000
#define LX_O_SYNC	010000

/*
 * Linux fcntl() commands
 */
#define LX_F_DUPFD	0
#define LX_F_GETFD	1
#define LX_F_SETFD	2
#define LX_F_GETFL	3
#define LX_F_SETFL	4
#define LX_F_GETLK	5
#define LX_F_SETLK	6
#define LX_F_SETLKW	7
#define LX_F_SETOWN	8	/*  for sockets. */
#define LX_F_GETOWN	9	/*  for sockets. */

/* for F_[GET|SET]FL */
#define LX_FD_CLOEXEC	1

/*
 * Linux lock types
 */
#define LX_F_RDLCK	0
#define LX_F_WRLCK	1
#define LX_F_UNLCK	2


struct lx_flock
{
	short	l_type;
	short	l_whence;
	long	l_start;
	long	l_len;
	int	l_pid;
};

#endif
