#if !defined(LX_RESOURCE_H)
#define	LX_RESOURCE_H

#include	<sys/time.h>

#define	LX_RUSAGE_SELF		0
#define	LX_RUSAGE_CHILDREN	(-1)
#define LX_RUSAGE_BOTH		(-2)

struct	lx_rusage {
	struct timeval ru_utime;	/* user time used */
	struct timeval ru_stime;	/* system time used */
	long	ru_maxrss;		/* maximum resident set size */
	long	ru_ixrss;		/* integral shared memory size */
	long	ru_idrss;		/* integral unshared data size */
	long	ru_isrss;		/* integral unshared stack size */
	long	ru_minflt;		/* page reclaims */
	long	ru_majflt;		/* page faults */
	long	ru_nswap;		/* swaps */
	long	ru_inblock;		/* block input operations */
	long	ru_oublock;		/* block output operations */
	long	ru_msgsnd;		/* messages sent */
	long	ru_msgrcv;		/* messages received */
	long	ru_nsignals;		/* signals received */
	long	ru_nvcsw;		/* voluntary context switches */
	long	ru_nivcsw;		/* involuntary " */
};

#define LX_RLIM_INFINITY	((long)(~0UL>>1))

struct lx_rlimit {
	long	rlim_cur;
	long	rlim_max;
};

#define	LX_PRIO_MIN	(-99)
#define	LX_PRIO_MAX	14

#define	LX_PRIO_PROCESS	0
#define	LX_PRIO_PGRP	1
#define	LX_PRIO_USER	2

/*
 * Resource limits
 */
#define LX_RLIMIT_CPU		0
#define LX_RLIMIT_FSIZE		1
#define LX_RLIMIT_DATA		2
#define LX_RLIMIT_STACK		3
#define LX_RLIMIT_CORE		4
#define LX_RLIMIT_RSS		5
#define LX_RLIMIT_NPROC		6
#define LX_RLIMIT_NOFILE	7

#define LX_RLIM_NLIMITS		8

#endif
