#if !defined(LX_SHM_H_)
#define LX_SHM_H_

#include "linux/ipc.h"


struct lx_shmid_ds {
	struct	lx_ipc_perm shm_perm;	/* operation perms */
	int	shm_segsz;		/* size of segment (bytes) */
	time_t	shm_atime;		/* last attach time */
	time_t	shm_dtime;		/* last detach time */
	time_t	shm_ctime;		/* last change time */
	unsigned short	shm_cpid;	/* pid of creator */
	unsigned short	shm_lpid;	/* pid of last operator */
	short	shm_nattch;		/* no. of current attaches */
	/* the following are private */
	unsigned short   shm_npages;	/* size of segment (pages) */
	unsigned long   *shm_pages;	/* array of ptrs to frames -> SHMMAX */ 
	void	*attaches;		/* descriptors for attaches */
};

/* permission flag for shmget */
#define LX_SHM_R		0400	/* or S_IRUGO from <linux/stat.h> */
#define LX_SHM_W		0200	/* or S_IWUGO from <linux/stat.h> */

/* mode for attach */
#define	LX_SHM_RDONLY	010000	/* read-only access */
#define	LX_SHM_RND	020000	/* round attach address to SHMLBA boundary */
#define	LX_SHM_REMAP	040000	/* take-over region on attach */

/* super user shmctl commands */
#define LX_SHM_LOCK 	11
#define LX_SHM_UNLOCK 	12

struct	lx_shminfo {
    int shmmax;	
    int shmmin;	
    int shmmni;	
    int shmseg;	
    int shmall;	
};


/* shm_mode upper byte flags */
#define	LX_SHM_DEST	01000	/* segment will be destroyed on last detach */
#define LX_SHM_LOCKED      02000   /* segment will not be swapped */

/* ipcs ctl commands */
#define LX_SHM_STAT 	13
#define LX_SHM_INFO 	14
struct lx_shm_info {
	int   used_ids;
	ulong shm_tot; /* total allocated shm */
	ulong shm_rss; /* total resident shm */
	ulong shm_swp; /* total swapped shm */
	ulong swap_attempts;
	ulong swap_successes;
};

#endif

