/*
 * Linux signal numbers
 */
#if !defined(LX_SIGNAL_H)
#define	LX_SIGNAL_H

typedef unsigned long lx_sigset_t;

#define LX_NSIG          32

#define LX_SIGHUP	 1
#define LX_SIGINT	 2
#define LX_SIGQUIT	 3
#define LX_SIGILL	 4
#define LX_SIGTRAP	 5
#define LX_SIGABRT	 6
#define LX_SIGIOT	 6
#define LX_SIGBUS	 7
#define LX_SIGFPE	 8
#define LX_SIGKILL	 9
#define LX_SIGUSR1	10
#define LX_SIGSEGV	11
#define LX_SIGUSR2	12
#define LX_SIGPIPE	13
#define LX_SIGALRM	14
#define LX_SIGTERM	15
#define LX_SIGSTKFLT	16
#define LX_SIGCHLD	17
#define LX_SIGCONT	18
#define LX_SIGSTOP	19
#define LX_SIGTSTP	20
#define LX_SIGTTIN	21
#define LX_SIGTTOU	22
#define LX_SIGURG	23
#define LX_SIGXCPU	24
#define LX_SIGXFSZ	25
#define LX_SIGVTALRM	26
#define LX_SIGPROF	27
#define LX_SIGWINCH	28
#define LX_SIGIO	29
#define LX_SIGPOLL	SIGIO
#define LX_SIGPWR	30
#define	LX_SIGUNUSED	31

#define LX_SA_NOCLDSTOP	1
#define LX_SA_STACK	0x08000000
#define LX_SA_RESTART	0x10000000
#define LX_SA_INTERRUPT	0x20000000
#define LX_SA_NOMASK	0x40000000
#define LX_SA_ONESHOT	0x80000000

#define LX_SIG_BLOCK	0
#define LX_SIG_UNBLOCK	1
#define LX_SIG_SETMASK	2

typedef void (*lx_sighandler_t)(int);

#define LX_SIG_DFL	((lx_sighandler_t)0)
#define LX_SIG_IGN	((lx_sighandler_t)1)
#define LX_SIG_ERR	((lx_sighandler_t)-1)

struct lx_sigaction {
	lx_sighandler_t	handler;
	lx_sigset_t	mask;
	unsigned long	flags;
	void		(*restorer)(void);
};

#endif
