/*
 * Copyright (C) 1996 Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#include	<errno.h>
#include	<sys/types.h>
#include	<sys/v86.h>
#include	<sys/sysi86.h>
#include	"lxrun.h"

int sysi86(int cmd, ...);

/*
 * assorted random system calls
 */

/*
 *	ioperm		(PARTLY IMPLEMENTED)
 *	iopl		(OSR5 only)
 *	vhangup		(NOT IMPLEMENTED)
 *	idle		(NOT IMPLEMENTED)
 *	vm86		(NOT IMPLEMENTED)
 *	modify_ldt	(NOT IMPLEMENTED)
 *	clone		(NOT IMPLEMENTED)
 *	sysctl		(NOT IMPLEMENTED)
 */

int
lx_ioperm(unsigned long fron, unsigned long num, int turn_on)
{
#ifdef OSR5
	return sysi86(SI86V86, V86SC_IOPL, turn_on ? 0x3000 : 0);
#else
	/* Untested.  Is this correct?  Does it even compile? */
	return sysi86(SI86IOPL, turn_on ? 3 : 0);
#endif
}

int
lx_iopl(int level)
{
#ifdef OSR5
	if (level > 3 || level < 0) {
		errno = EINVAL;
		return -1;
	}

	return sysi86(SI86V86, V86SC_IOPL, level << 24);
#else
	/* unimplemented for non-OSR5 */
	errno = ENOSYS;
	return -1;
#endif
}

int lx_vhangup()	{ errno = ENOSYS; return -1; }	
int lx_idle()		{ errno = ENOSYS; return -1; }	
int lx_vm86()		{ errno = ENOSYS; return -1; }	
int lx_modify_ldt()	{ errno = ENOSYS; return -1; }	
int lx_clone()		{ errno = ENOSYS; return -1; }	
int lx_sysctl()		{ errno = ENOSYS; return -1; }	
