/*
 * Copyright (C) 1996 Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#include	<errno.h>
#include	<string.h>
#include	<sys/sem.h>
#include	"lxrun.h"
#include	"linux/sem.h"

static int
copy_in_semid_ds(struct lx_semid_ds *from, struct semid_ds *to)
{
	if (! from || !verify_read(from, sizeof(*from)))
		return -1;

	memset(to, 0, sizeof(*to));

	to->sem_perm.key	= from->sem_perm.key;
	to->sem_perm.uid	= from->sem_perm.uid;
	to->sem_perm.gid	= from->sem_perm.gid;
	to->sem_perm.cuid	= from->sem_perm.cuid;
	to->sem_perm.cgid	= from->sem_perm.cgid;
	to->sem_perm.mode	= from->sem_perm.mode;
	to->sem_perm.seq	= from->sem_perm.seq;

	to->sem_otime		= from->sem_otime;
	to->sem_ctime		= from->sem_ctime;
	to->sem_nsems		= from->sem_nsems;

	return 0;
}


static int
copy_out_semid_ds(struct semid_ds *from, struct lx_semid_ds *to)
{
	if (! to || !verify_write(from, sizeof(*to)))
		return -1;

	memset(to, 0, sizeof(*to));

	to->sem_perm.key	= from->sem_perm.key;
	to->sem_perm.uid	= from->sem_perm.uid;
	to->sem_perm.gid	= from->sem_perm.gid;
	to->sem_perm.cuid	= from->sem_perm.cuid;
	to->sem_perm.cgid	= from->sem_perm.cgid;
	to->sem_perm.mode	= from->sem_perm.mode;
	to->sem_perm.seq	= from->sem_perm.seq;

	to->sem_otime		= from->sem_otime;
	to->sem_ctime		= from->sem_ctime;
	to->sem_nsems		= from->sem_nsems;

	return 0;
}

int
lx_semget(key_t key, int nsems, int semflg)
{
	errno = ENOSYS;
	return -1;
}

int
lx_semop(int semid, struct lx_sembuf *sops, unsigned nsops)
{
	errno = ENOSYS;
	return -1;
}

int
lx_semctl(int semid, int semnum, int cmd, void *arg)
{
	errno = ENOSYS;
	return -1;
}
