/*
 * Copyright (C) 1997 Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#if !defined(TRACE_H)
#define TRACE_H

#undef TRACE_ARG
#define	TRACE_ARG(name)	a_##name,
enum arg_type
{
#include "traceargs.h"
    a_num_arg_types
};
#undef TRACE_ARG

struct trace_info
{
	char	*name;
	char	flags;
	char	ret;
	char	argtypes[6];
};

extern int  (*print_arg[])(struct trace_info *, char *, int *, int);

#define	PRINT_ARG(t, buf, args, i)	\
	print_arg[(t)->argtypes[(i)]](t, buf, args, i)

#define	PRINT_RET(t, buf, rval)	\
	print_arg[(t)->ret](t, buf, &rval, 0)


#define	ARG(x)			(a_##x)
#define	RET(x)			ARG(x)
#define	ARGS0()			0
#define	ARGS1(a1)		ARG(a1)
#define	ARGS2(a1,a2)		ARG(a1), ARG(a2)
#define	ARGS3(a1,a2,a3)		ARG(a1), ARG(a2), ARG(a3)
#define	ARGS4(a1,a2,a3,a4)	ARG(a1), ARG(a2), ARG(a3), ARG(a4)
#define	ARGS5(a1,a2,a3,a4,a5)	ARG(a1), ARG(a2), ARG(a3), ARG(a4), ARG(a5)
#define	ARGS6(a1,a2,a3,a4,a5,a6) ARG(a1), ARG(a2), ARG(a3), ARG(a4), ARG(a5), ARG(a6)

#endif
